ON_Material Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_material.h>`

Inheritance diagram for ON_Material:

## Public Member Functions

| ON_Material ()
| ~ON_Material ()
bool | operator== (const ON_Material &) const
bool | operator!= (const ON_Material &) const
void | Default ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
ON_UUID | ModelObjectId () const
int | Compare (const ON_Material &other) const
ON_Color | Ambient () const
ON_Color | Diffuse () const
ON_Color | Emission () const
ON_Color | Specular () const
void | SetAmbient (ON_Color)
void | SetDiffuse (ON_Color)
void | SetEmission (ON_Color)
void | SetSpecular (ON_Color)
double | Shine () const
void | SetShine (double)
double | Transparency () const
void | SetTransparency (double)
int | MaterialIndex () const
void | SetMaterialIndex (int)
ON_UUID | MaterialPlugInUuid () const
void | SetMaterialPlugInUuid (ON_UUID)
const wchar_t * | MaterialName () const
void | SetMaterialName (const wchar_t *)
int | FindTexture (ON_UUID texture_id) const
int | FindTexture (const wchar_t *filename, ON_Texture::TYPE type, int i0=-1) const
int | AddTexture (const ON_Texture &tx)
int | AddTexture (const wchar_t *filename, ON_Texture::TYPE type)
int | DeleteTexture (const wchar_t *filename, ON_Texture::TYPE type)
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static double | MaxShine ()

## Public Attributes

ON_UUID | m_material_id
int | m_material_index
ON_wString | m_material_name
ON_wString | m_flamingo_library
ON_Color | m_ambient
ON_Color | m_diffuse
ON_Color | m_emission
ON_Color | m_specular
ON_Color | m_reflection
ON_Color | m_transparent
double | m_index_of_refraction
double | m_reflectivity
double | m_shine
double | m_transparency
bool | m_bShared
bool | m_bDisableLighting
ON_ObjectArray< ON_Texture > | m_textures
ON_SimpleArray< ON_UuidIndex > | m_material_channel
ON_UUID | m_plugin_id

## Detailed Description

Definition at line 25 of file opennurbs_material.h.

## Constructor & Destructor Documentation

## ON_Material()

ON_Material::ON_Material | ( |  | ) |

## ~ON_Material()

ON_Material::~ON_Material | ( |  | ) |

## Member Function Documentation

## AddTexture() [1/2]

int ON_Material::AddTexture | ( | const ON_Texture & | tx | ) |

## AddTexture() [2/2]

int ON_Material::AddTexture | ( | const wchar_t * | filename,
|  | ON_Texture::TYPE | type
| ) |  |

## Ambient()

ON_Color ON_Material::Ambient | ( |  | ) | const

## Compare()

int ON_Material::Compare | ( | const ON_Material & | other | ) | const

## Default()

void ON_Material::Default | ( |  | ) |

## DeleteTexture()

int ON_Material::DeleteTexture | ( | const wchar_t * | filename,
|  | ON_Texture::TYPE | type
| ) |  |

## Diffuse()

ON_Color ON_Material::Diffuse | ( |  | ) | const

## Dump()

void ON_Material::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## Emission()

ON_Color ON_Material::Emission | ( |  | ) | const

## FindTexture() [1/2]

int ON_Material::FindTexture | ( | ON_UUID | texture_id | ) | const

## FindTexture() [2/2]

int ON_Material::FindTexture | ( | const wchar_t * | filename,
|  | ON_Texture::TYPE | type,
|  | int | i0 = `-1`
| ) |  | const

## IsValid()

ON_BOOL32 ON_Material::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## MaterialIndex()

int ON_Material::MaterialIndex | ( |  | ) | const

## MaterialName()

const wchar_t* ON_Material::MaterialName | ( |  | ) | const

## MaterialPlugInUuid()

ON_UUID ON_Material::MaterialPlugInUuid | ( |  | ) | const

## MaxShine()

static double ON_Material::MaxShine | ( |  | ) |

static

## ModelObjectId()

ON_UUID ON_Material::ModelObjectId | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## ObjectType()

ON::object_type ON_Material::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## operator!=()

bool ON_Material::operator!= | ( | const ON_Material & |  | ) | const

## operator==()

bool ON_Material::operator== | ( | const ON_Material & |  | ) | const

## Read()

ON_BOOL32 ON_Material::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## SetAmbient()

void ON_Material::SetAmbient | ( | ON_Color |  | ) |

## SetDiffuse()

void ON_Material::SetDiffuse | ( | ON_Color |  | ) |

## SetEmission()

void ON_Material::SetEmission | ( | ON_Color |  | ) |

## SetMaterialIndex()

void ON_Material::SetMaterialIndex | ( | int |  | ) |

## SetMaterialName()

void ON_Material::SetMaterialName | ( | const wchar_t * |  | ) |

## SetMaterialPlugInUuid()

void ON_Material::SetMaterialPlugInUuid | ( | ON_UUID |  | ) |

## SetShine()

void ON_Material::SetShine | ( | double |  | ) |

## SetSpecular()

void ON_Material::SetSpecular | ( | ON_Color |  | ) |

## SetTransparency()

void ON_Material::SetTransparency | ( | double |  | ) |

## Shine()

double ON_Material::Shine | ( |  | ) | const

## Specular()

ON_Color ON_Material::Specular | ( |  | ) | const

## Transparency()

double ON_Material::Transparency | ( |  | ) | const

## Write()

ON_BOOL32 ON_Material::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_ambient

ON_Color ON_Material::m_ambient

Definition at line 147 of file opennurbs_material.h.

## m_bDisableLighting

bool ON_Material::m_bDisableLighting

Definition at line 166 of file opennurbs_material.h.

## m_bShared

bool ON_Material::m_bShared

Definition at line 158 of file opennurbs_material.h.

## m_diffuse

ON_Color ON_Material::m_diffuse

Definition at line 148 of file opennurbs_material.h.

## m_emission

ON_Color ON_Material::m_emission

Definition at line 149 of file opennurbs_material.h.

## m_flamingo_library

ON_wString ON_Material::m_flamingo_library

Definition at line 144 of file opennurbs_material.h.

## m_index_of_refraction

double ON_Material::m_index_of_refraction

Definition at line 153 of file opennurbs_material.h.

## m_material_channel

ON_SimpleArray<ON_UuidIndex> ON_Material::m_material_channel

Definition at line 320 of file opennurbs_material.h.

## m_material_id

ON_UUID ON_Material::m_material_id

Definition at line 132 of file opennurbs_material.h.

## m_material_index

int ON_Material::m_material_index

Definition at line 139 of file opennurbs_material.h.

## m_material_name

ON_wString ON_Material::m_material_name

Definition at line 142 of file opennurbs_material.h.

## m_plugin_id

ON_UUID ON_Material::m_plugin_id

Definition at line 322 of file opennurbs_material.h.

## m_reflection

ON_Color ON_Material::m_reflection

Definition at line 151 of file opennurbs_material.h.

## m_reflectivity

double ON_Material::m_reflectivity

Definition at line 154 of file opennurbs_material.h.

## m_shine

double ON_Material::m_shine

Definition at line 155 of file opennurbs_material.h.

## m_specular

ON_Color ON_Material::m_specular

Definition at line 150 of file opennurbs_material.h.

## m_textures

ON_ObjectArray<ON_Texture> ON_Material::m_textures

Definition at line 300 of file opennurbs_material.h.

## m_transparency

double ON_Material::m_transparency

Definition at line 156 of file opennurbs_material.h.

## m_transparent

ON_Color ON_Material::m_transparent

Definition at line 152 of file opennurbs_material.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_material.h